import { Hyper } from '../Hyper';
/* End adapted code */
export function is_object(raw, failure) {
    if (raw === null || typeof raw !== 'object' || Array.isArray(raw))
        failure.throw('Is not object');
}
export class HyperObject extends Hyper {
    constructor(
    /**
     * Object schema
     */
    schema, ...hyper) {
        super(...hyper);
        this.schema = schema;
    }
}
export function object_core(check_length, value) {
    const keys = new Set(Object.keys(value));
    return new HyperObject(value, 'object', function (raw, failure) {
        is_object(raw, failure);
        if (check_length) {
            const raw_keys = Object.keys(raw);
            for (const key of raw_keys) {
                if (!keys.has(key))
                    failure.fork(key).throw('Object has extra keys');
            }
        }
        const result = { ...raw };
        for (const key of keys) {
            if (!(key in raw)) {
                try {
                    value[key].hyper(undefined, failure.fork(key));
                }
                catch {
                    failure.fork(key).throw('Object is missing keys');
                }
            }
            result[key] = value[key].hyper(raw[key], failure.fork(key));
        }
        return result;
    });
}
